'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RouteContext = exports.Lifecycle = exports.History = undefined;
exports.default = connect;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function connect() {
  for (var _len = arguments.length, hocs = Array(_len), _key = 0; _key < _len; _key++) {
    hocs[_key] = arguments[_key];
  }

  var _hocs$reduce = hocs.reduce(function (accum, hoc) {
    var _hoc$wrappedComponent = hoc.wrappedComponentProps;
    var wrappedComponentProps = _hoc$wrappedComponent === undefined ? {} : _hoc$wrappedComponent;
    var _hoc$propTypes = hoc.propTypes;
    var propTypes = _hoc$propTypes === undefined ? {} : _hoc$propTypes;
    var _hoc$contextTypes = hoc.contextTypes;
    var contextTypes = _hoc$contextTypes === undefined ? {} : _hoc$contextTypes;
    var _hoc$childContextType = hoc.childContextTypes;
    var childContextTypes = _hoc$childContextType === undefined ? {} : _hoc$childContextType;

    var etc = _objectWithoutProperties(hoc, ['wrappedComponentProps', 'propTypes', 'contextTypes', 'childContextTypes']);

    Object.assign(wrappedComponentProps, accum.wrappedComponentProps);
    propTypes = mergeTypes(propTypes, accum.propTypes);
    contextTypes = mergeTypes(contextTypes, accum.contextTypes);
    childContextTypes = mergeTypes(childContextTypes, accum.childContextTypes);

    return _extends({}, accum, {
      wrappedComponentProps: wrappedComponentProps,
      propTypes: propTypes,
      contextTypes: contextTypes,
      childContextTypes: childContextTypes
    }, etc);
  }, {});

  var wrappedComponentProps = _hocs$reduce.wrappedComponentProps;

  var Component = _objectWithoutProperties(_hocs$reduce, ['wrappedComponentProps']);

  applyTypes(Component.childContextTypes, Component.propTypes, Component.contextTypes);

  wrappedComponentProps = Object.entries(wrappedComponentProps);
  console.log(wrappedComponentProps);

  var Connect = function Connect(WrappedComponent) {
    Component.render = function () {
      wrappedComponentProps.reduce((accum, [key, value]));
      return _react2.default.createElement(WrappedComponent);
    };
    return _react2.default.createClass(Component);
  };

  console.log(Connect);
}

function applyTypes() {
  for (var _len2 = arguments.length, typeProps = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    typeProps[_key2] = arguments[_key2];
  }

  typeProps.forEach(function (typeProp) {
    Object.keys(typeProp).forEach(function (key) {
      typeProp[key] = key === 'history' ? typeProp[key].isRequired ? _reactRouter.PropTypes.history.isRequired : _reactRouter.PropTypes.history : key === 'route' ? typeProp[key].isRequired ? _reactRouter.PropTypes.route.isRequired : _reactRouter.PropTypes.route : _reactRouter.PropTypes.any;
    });
  });
}

function mergeTypes() {
  var a = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var b = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var merged = _extends({}, a);

  for (var _key3 in b) {
    if (b.hasOwnProperty(_key3)) {
      if (a[_key3] == null || b[_key3].isRequired) {
        merged[_key3] = b[_key3];
      }
    }
  }

  return merged;
}

var History = exports.History = {
  wrappedComponentProps: {
    history: function history() {
      return undefined.context.history;
    }
  },

  contextTypes: { history: { isRequired: false } }
};

var Lifecycle = exports.Lifecycle = {
  displayName: 'Lifecycle',

  wrappedComponentProps: {
    refs: function refs() {
      return function (instance) {
        return undefined.setupLifecyle(instance);
      };
    }
  },

  propTypes: {
    route: { isRequired: false }
  },

  contextTypes: {
    history: { isRequired: true },
    route: { isRequired: false }
  },

  setupLifecyle: function setupLifecyle(wrappedInstance) {
    if (wrappedInstance == null) {
      return;
    }

    invariant(wrappedInstance.routerWillLeave, 'The Lifecycle higher-order component requires you to define a routerWillLeave method');

    var route = this.props.route || this.context.route;

    invariant(route, 'The Lifecycle higher-order component must be used on either a) a <Route component> ' + 'or b) a descendant of a <Route component> that uses the RouteContext mixin');

    this._unlistenBeforeLeavingRoute = this.context.history.listenBeforeLeavingRoute(route, wrappedInstance.routerWillLeave);
  },
  componentWillUnmount: function componentWillUnmount() {
    if (this._unlistenBeforeLeavingRoute) {
      this._unlistenBeforeLeavingRoute();
    }
  }
};

var RouteContext = exports.RouteContext = {
  propTypes: {
    route: { isRequired: true }
  },

  childContextTypes: {
    route: { isRequired: true }
  },

  getChildContext: function getChildContext() {
    return { route: undefined.props.route };
  }
};