'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A higher-order-component that passes "history" as a property to components.
 */

function connectLifecycle(WrappedComponent) {
  var ConnectLifecycle = (function (_Component) {
    _inherits(ConnectLifecycle, _Component);

    function ConnectLifecycle() {
      _classCallCheck(this, ConnectLifecycle);

      return _possibleConstructorReturn(this, Object.getPrototypeOf(ConnectLifecycle).apply(this, arguments));
    }

    _createClass(ConnectLifecycle, [{
      key: 'setupLifecyle',
      value: function setupLifecyle(wrappedInstance) {
        if (wrappedInstance == null) {
          return;
        }

        (0, _invariant2.default)(wrappedInstance.routerWillLeave, 'The Lifecycle higher-order component requires you to define a routerWillLeave method');

        var route = this.props.route || this.context.route;

        (0, _invariant2.default)(route, 'The Lifecycle higher-order component must be used on either a) a <Route component> ' + 'or b) a descendant of a <Route component> that uses the RouteContext mixin');

        this._unlistenBeforeLeavingRoute = this.context.history.listenBeforeLeavingRoute(route, wrappedInstance.routerWillLeave);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (this._unlistenBeforeLeavingRoute) {
          this._unlistenBeforeLeavingRoute();
        }
      }
    }, {
      key: 'render',
      value: function render() {
        var _this2 = this;

        return _react2.default.createElement(WrappedComponent, _extends({ ref: function ref(instance) {
            return _this2.setupLifecyle(instance);
          }
        }, this.props, {
          __source: {
            fileName: '../../../src/connectLifecycle.js',
            lineNumber: 43
          }
        }));
      }
    }]);

    return ConnectLifecycle;
  })(_react.Component);

  ConnectLifecycle.contextTypes = {
    history: _reactRouter.PropTypes.history.isRequired,
    // Nested children receive the route as context, either
    // set by the route component using the RouteContext mixin
    // or by some other ancestor.
    route: _reactRouter.PropTypes.route
  }, ConnectLifecycle.propTypes = {
    // Route components receive the route object as a prop.
    route: _reactRouter.PropTypes.route
  }, ConnectLifecycle.displayName = 'ConnectLifecycle(' + getDisplayName(WrappedComponent) + ')';
  ConnectLifecycle.WrappedComponent = WrappedComponent;

  return ConnectLifecycle;
}

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

exports.default = connectLifecycle;